/// Utility class. Don't try to use it!
///
/// This contains a custom position for the [Badge]
class TBadgePosition {
  /// Distance to the top side of a parent widget.
  final double? top;

  /// Distance to the end side of a parent widget.
  final double? end;

  /// Distance to the start side of a parent widget.
  final double? start;

  /// Distance to the bottom side of a parent widget.
  final double? bottom;

  /// Indicates that the badge is in center of parent widget
  final bool isCenter;

  /// This creates a new instance of this widget
  const TBadgePosition._({
    this.top,
    this.end,
    this.bottom,
    this.start,
    this.isCenter = false,
  });

  /// Factory method that creates a new instance of this widget
  /// according to the center
  factory TBadgePosition.center() {
    return const TBadgePosition._(isCenter: true);
  }

  /// Factory method that creates a new instance of this widget
  /// according to [top] and [start]
  factory TBadgePosition.topStart({double top = -5, double start = -10}) {
    return TBadgePosition._(top: top, start: start);
  }

  /// Factory method that creates a new instance of this widget
  /// according to [top] and [end]
  factory TBadgePosition.topEnd({double top = -8, double end = -10}) {
    return TBadgePosition._(top: top, end: end);
  }

  /// Factory method that creates a new instance of this widget
  /// according to [bottom] and [end]
  factory TBadgePosition.bottomEnd({double bottom = -8, double end = -10}) {
    return TBadgePosition._(bottom: bottom, end: end);
  }

  /// Factory method that creates a new instance of this widget
  /// according to [bottom] and [start]
  factory TBadgePosition.bottomStart({double bottom = -8, double start = -10}) {
    return TBadgePosition._(bottom: bottom, start: start);
  }

  factory TBadgePosition.custom({
    double? start,
    double? end,
    double? top,
    double? bottom,
    bool isCenter = false,
  }) {
    return TBadgePosition._(top: top, end: end, bottom: bottom, start: start, isCenter: isCenter);
  }
}
