import 'package:flutter/material.dart';

import '../../badges.dart';
import '../painters/instagram_badge_shape_painter.dart';
import '../painters/twitter_badge_shape_painter.dart';

class DrawingUtils {
  static CustomPainter? drawBadgeShape({
    required TBadgeShape shape,
    Color? color,
    TBadgeGradient? badgeGradient,
    TBadgeGradient? borderGradient,
    BorderSide? borderSide,
  }) {
    switch (shape) {
      case TBadgeShape.twitter:
        return TwitterBadgeShapePainter(
          color: color,
          badgeGradient: badgeGradient,
          borderSide: borderSide,
          borderGradient: borderGradient,
        );
      case TBadgeShape.instagram:
        return InstagramBadgeShapePainter(
          color: color,
          badgeGradient: badgeGradient,
          borderSide: borderSide,
          borderGradient: borderGradient,
        );
      case TBadgeShape.square:
      case TBadgeShape.circle:
        break;
    }
    return null;
  }
}
